import { EditorView } from "@codemirror/next/view";
import { EditorState } from "@codemirror/next/state";
import { ActiveResult } from "./state";
export interface Completion {
    label: string;
    detail?: string;
    info?: string | ((completion: Completion) => Node);
    apply?: string | ((view: EditorView, completion: Completion, from: number, to: number) => void);
    type?: string;
    boost?: number;
}
export declare class CompletionContext {
    readonly state: EditorState;
    readonly pos: number;
    readonly explicit: boolean;
    tokenBefore(types: readonly string[]): {
        from: number;
        to: number;
        text: string;
        type: import("lezer-tree").NodeType;
    } | null;
    matchBefore(expr: RegExp): {
        from: number;
        to: number;
        text: string;
    } | null;
    get aborted(): boolean;
    addEventListener(_type: "abort", listener: () => void): void;
}
export declare type CompletionSource = (context: CompletionContext) => CompletionResult | null | Promise<CompletionResult | null>;
export interface CompletionResult {
    from: number;
    to?: number;
    options: readonly Completion[];
    span?: RegExp;
}
export declare class Option {
    readonly completion: Completion;
    readonly source: ActiveResult;
    readonly match: readonly number[];
    constructor(completion: Completion, source: ActiveResult, match: readonly number[]);
}
export declare function cur(state: EditorState): number;
export declare function ensureAnchor(expr: RegExp, start: boolean): RegExp;
export declare function applyCompletion(view: EditorView, option: Option): void;
//# sourceMappingURL=completion.d.ts.map