import { EditorView, ViewUpdate } from "@codemirror/next/view";
import { Facet, Extension } from "@codemirror/next/state";
export declare function tooltips(): Extension;
export interface Tooltip {
    pos: number;
    end?: number;
    create(view: EditorView): TooltipView;
    style?: string;
    above?: boolean;
    strictSide?: boolean;
}
export interface TooltipView {
    dom: HTMLElement;
    mount?(view: EditorView): void;
    update?(update: ViewUpdate): void;
    positioned?(): void;
}
export declare const showTooltip: Facet<Tooltip, readonly Tooltip[]>;
export declare function hoverTooltip(source: (view: EditorView, check: (from: number, to: number) => boolean) => Tooltip | null, options?: {
    hideOnChange?: boolean;
}): Extension;
//# sourceMappingURL=tooltip.d.ts.map