import { SpanIterator } from "@codemirror/next/rangeset";
import { DecorationSet, Decoration, MarkDecoration } from "./decoration";
import { BlockView, LineView, BlockWidgetView } from "./blockview";
import { InlineView } from "./inlineview";
import { Text, TextIterator } from "@codemirror/next/text";
export declare class ContentBuilder implements SpanIterator<Decoration> {
    private doc;
    pos: number;
    end: number;
    content: BlockView[];
    curLine: LineView | null;
    breakAtStart: number;
    openStart: number;
    openEnd: number;
    cursor: TextIterator;
    text: string;
    skip: number;
    textOff: number;
    constructor(doc: Text, pos: number, end: number);
    posCovered(): boolean;
    getLine(): LineView;
    addWidget(view: BlockWidgetView): void;
    finish(): void;
    wrapMarks(view: InlineView, active: readonly MarkDecoration[]): InlineView;
    buildText(length: number, active: readonly MarkDecoration[], openStart: number): void;
    span(from: number, to: number, active: MarkDecoration[], openStart: number): void;
    point(from: number, to: number, deco: Decoration, active: MarkDecoration[], openStart: number): void;
    static build(text: Text, from: number, to: number, decorations: readonly DecorationSet[]): {
        content: BlockView[];
        breakAtStart: number;
        openStart: number;
        openEnd: number;
    };
}
//# sourceMappingURL=buildview.d.ts.map